local ADDONNAME, ns = ...
ns = ns or {}

-- load locale
local L = LibStub("AceLocale-3.0"):GetLocale(ADDONNAME)

-- load libs
local LSM = LibStub("LibSharedMedia-3.0")
local LSK = LibStub("LibSink-2.0")

-- WoW APIs
local _G = _G

-- Lua API
local rawget, rawset, type = rawget, rawset, type

-- GLOBALS: MVAnnouncerDefaults


ns.defaultSoundName = "Gruntling Horn"
LSM:Register(LSM.MediaType.SOUND, ns.defaultSoundName, "Sound/Events/gruntling_horn_bb.ogg")

ns.objectIconTextureSize = 256
ns.OBJECTICONS_texture = "Interface\\MINIMAP\\OBJECTICONS.blp"
ns.OBJECTICONS_chatTexture = ("|T%s:%%d:%%d:0:0:%d:%d:%%d:%%d:%%d:%%d|t"):format(ns.OBJECTICONS_texture,ns.objectIconTextureSize,ns.objectIconTextureSize)
ns.OBJECTICONS_coords = setmetatable({}, {__index = function(t,k)
    local v = rawget(t, k)
    if type(v) ~= "table" then
        v = {_G.GetObjectIconTextureCoords(k)}
        rawset(t,k,v)
    end
    return v
end
})

ns.objectIconTypes = {
    [40] = "IconChest",
    [41] = "IconBossRar",
    [42] = "IconCombat",
    [43] = "IconChestEpic",
    [44] = "IconBossRarEpic",
    [45] = "IconCombatEpic",
}

ns.foundCooldowns = setmetatable({}, {__index=function(t,key)
    local v = rawget(t, key) or _G.GetTime()
    
    rawset(t, key, _G.GetTime()+ns.db.profile.cooldownTime)

    return v
end})

ns.SPLITKEY = "|"
ns.sinkTable = setmetatable({}, {__index=function(t,key)
    local v = rawget(t, key)

    if type(v) ~= "table" then
        v = LSK:Embed({})
        if key:find(ns.SPLITKEY) < 2 then
            v:SetSinkStorage({})
        else
            local objectIcon, name, sinkKey = ns.SPLITKEY:split(key)
            v:SetSinkStorage(ns.db.profile.objectIconTypeOfInterest[objectIcon][name].sinks[sinkKey])
        end
        rawset(t, key, v)
    end

    return v
end})

ns.defaults = {
    profile = {
        cooldownTime = 10,
        active = true,
        objectIconTypeOfInterest = {
            ['**'] = {
                active = true,
                ['**'] = MVAnnouncerDefaults,
            },
        },
    }
}